<?php



class Migration
{

	public $dbType;
	public $dbFileName;
	public $dbLocation;
	public $dbUsername;
	public $dbPassword;
	
	
	function init()
	{
		
	
		chdir('../');
	
		// 設定時間時區
		date_default_timezone_set('Asia/Taipei');
		
		// 設定資料庫
		$type = 'sqlite';
		//$type = 'mysql';
		if($type == 'mysql')
		{
			$this->dbType = 'mysql';
			$this->dbLocation = 'host=localhost;dbname=startup';
			$this->dbUsername = 'root';
			$this->dbPassword = '';
		}
		else
		{
			$databaseFileName = 'AppData/Database/startup.sqlite';
			$newDatabaseFileName = $databaseFileName.'-'.date('YmdHis').'.sqlite';
	
			if(file_exists($databaseFileName) == false)
			{
				return false;
			}
			
			if(copy($databaseFileName, $newDatabaseFileName) == false)
			{
				return false;
			}
			
			chmod($newDatabaseFileName, 0777);
		
			$this->dbType = 'sqlite';
			$this->dbFileName = $newDatabaseFileName;
		}
	}
	

	function upgrade()
	{	
		
		$currentDatabaseVersion = $this->getDatabaseVersion();
		printf("現在資料庫路徑:%s\n", $this->dbFileName);
		printf("現在資料庫版本:%s\n", $currentDatabaseVersion);
		
		
		$wantedDatabaseVersion = 2;
		if($currentDatabaseVersion >= $wantedDatabaseVersion)
		{
			printf("不需要升級。\n");	
			return true;
		}
		
		
		
		printf("最新資料庫版本:%s\n", $wantedDatabaseVersion);
		
		
		$db = null;
		if($this->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$this->dbLocation, $this->dbUsername, $this->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$this->dbFileName);
		}
		
		
		
		$query = $this->getSQL();
		printf("結構升級 ...");
		$db->exec($query);
		printf(" OK\n");
		
		
		
		printf("資料升級 .");
		$this->writeData();
		printf(" OK\n");
		
		
		
		printf("耶 ~ 資料庫升級成功。\n");
		return true;
	}
	
	
	
	
	
	function getSQL()
	{
		
$query = 
'

BEGIN TRANSACTION;
ALTER TABLE "StoreFolder" RENAME TO "StoreFolder_ME_TMP";
CREATE TABLE "StoreFolder" (
"id" INTEGER PRIMARY KEY AUTOINCREMENT,
"name" TEXT,
"description" TEXT,
"ownerID" INTEGER,
"folderVersion" TEXT,
"folderType" TEXT,
"folderSize" TEXT,
"folderIndex" TEXT,
"isOpen" TEXT,
"appID" TEXT,
"appVersion" TEXT,
"appDownloadable" TEXT,
"creationTime" INTEGER,
"tag" TEXT,
"timestamp" INTEGER
);
INSERT INTO "StoreFolder"  ("id", "name", "description", "ownerID", "folderVersion", "folderType", "folderSize", "folderIndex", "isOpen", "appID", "appVersion", "appDownloadable", "creationTime", "tag", "timestamp") SELECT "id", "name", "description", "ownerID", "folderVersion", "folderType", "folderSize", "folderIndex", "isOpen", "appID", "appVersion", "appDownloadable", "creationTime", "tag", "timestamp" FROM "StoreFolder_ME_TMP";
DROP TABLE "StoreFolder_ME_TMP";
COMMIT;


BEGIN TRANSACTION;
ALTER TABLE "StoreFile" RENAME TO "StoreFile_ME_TMP";
CREATE TABLE "StoreFile" (
"id" INTEGER PRIMARY KEY AUTOINCREMENT,
"name" TEXT,
"description" TEXT,
"filename" TEXT,
"fileSize" TEXT,
"folderID" INTEGER,
"creationTime" INTEGER,
"tag" TEXT,
"timestamp" INTEGER
);
INSERT INTO "StoreFile"  ("id", "name", "description", "filename", "fileSize", "folderID", "creationTime", "tag", "timestamp") SELECT "id", "name", "description", "filename", "fileSize", "folderID", "creationTime", "tag", "timestamp" FROM "StoreFile_ME_TMP";
DROP TABLE "StoreFile_ME_TMP";
COMMIT;


BEGIN TRANSACTION;
ALTER TABLE "DeveloperFolder" RENAME TO "DeveloperFolder_ME_TMP";
CREATE TABLE "DeveloperFolder" (
"id" INTEGER PRIMARY KEY AUTOINCREMENT,
"name" TEXT,
"description" TEXT,
"ownerID" INTEGER,
"isOpen" TEXT,
"storeFolderIDs" TEXT,
"appID" TEXT,
"appType" TEXT,
"appBinaryFile" TEXT,
"appReviewRequest" TEXT,
"appReviewStatus" TEXT,
"appReviewStatusName" TEXT,
"appVersion" TEXT,
"appCategory" TEXT,
"appRating" TEXT,
"appIconImage" TEXT,
"appScreenShot1" TEXT,
"appScreenShot2" TEXT,
"appScreenShot3" TEXT,
"appScreenShot4" TEXT,
"appScreenShot5" TEXT,
"appVideo" TEXT,
"appPrice" TEXT,
"appKeywords" TEXT,
"appCopyright" TEXT,
"appUpdateInformation" TEXT,
"appBeginDate" TEXT,
"appEndDate" TEXT,
"appDownloadable" TEXT,
"creationTime" INTEGER,
"tag" TEXT,
"timestamp" INTEGER
);
INSERT INTO "DeveloperFolder"  ("id", "name", "description", "ownerID", "storeFolderIDs", "appID", "appType", "appBinaryFile", "appReviewRequest", "appReviewStatus", "appReviewStatusName", "appVersion", "appCategory", "appRating", "appIconImage", "appScreenShot1", "appScreenShot2", "appScreenShot3", "appScreenShot4", "appScreenShot5", "appVideo", "appPrice", "appKeywords", "appCopyright", "appUpdateInformation", "appBeginDate", "appEndDate", "appDownloadable", "creationTime", "tag", "timestamp") SELECT "id", "name", "description", "ownerID", "storeFolderID", "appID", "appType", "appBinaryFile", "appReviewRequest", "appReviewStatus", "appReviewStatusName", "appVersion", "appCategory", "appRating", "appIconImage", "appScreenShot1", "appScreenShot2", "appScreenShot3", "appScreenShot4", "appScreenShot5", "appVideo", "appPrice", "appKeywords", "appCopyright", "appUpdateInformation", "appBeginDate", "appEndDate", "appDownloadable", "creationTime", "tag", "timestamp" FROM "DeveloperFolder_ME_TMP";
DROP TABLE "DeveloperFolder_ME_TMP";
COMMIT;



UPDATE "Setting" SET "value" = 2 WHERE name = "version";


';

		return $query;
	}
	
	
	
	
	function writeData()
	{
		require_once('ViewControllers/Application.php');
		$application = Application::sharedApplication();
		//$application->init();
		$application->dbType = $this->dbType;
		$application->dbFileName = $this->dbFileName;
		$application->dbLocation = $this->dbLocation;
		$application->dbUsername = $this->dbUsername;
		$application->dbPassword = $this->dbPassword;
		$application->deubgEnabled = false;
		

		
			
			
		
		/*
		require_once('Models/User.php');
		$users = User::findByConditions('', array());
		for($i=0;$i<count($users);$i++)
		{
			$user = $users[$i];

	
			if($i%10 == 0)
			{
				printf(".");
				usleep(1*10);
			}
		}
		*/
		
		
		
		
		return;
	}
	
	
	
	
	
	
	
	function getDatabaseVersion()
	{
		$db = null;
		if($this->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$this->dbLocation, $this->dbUsername, $this->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$this->dbFileName);
		}
		
		$query = sprintf("SELECT * FROM Setting WHERE name=?");
		$st = $db->prepare($query);
		
		$values = array("version");
		$st->execute($values);	
		
		$row = $st->fetch(PDO::FETCH_ASSOC);
		if($row == false)
		{
			return null;
		}
		return $row['value'];
	}


	function setDatabaseVersion($version)
	{
		$db = null;
		if($this->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$this->dbLocation, $this->dbUsername, $this->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$this->dbFileName);
		}
		
		$query = sprintf('UPDATE "Setting" SET "value" = ? WHERE name = "version";');
		$st = $db->prepare($query);
		$values = array($version);
		$st->execute($values);	
	
		return true;	
	}

}



$migration = new Migration();
$migration->init();
$migration->upgrade();



?>