<?php

class Model
{
	
	function init()
	{
	
	}
	
	
	function save()
	{
	
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		//$app->debug($className." save");
		
		
		/*
		// 除錯用
		$myClassName = get_class($this);
		$vars = get_object_vars($this);
		$parent = get_parent_class($this);
		$pvars = get_class_vars($parent);
		$cvars = get_class_vars($className);
		$app->debug($myClassName);
		$app->debug(print_r($vars, true));
		$app->debug(print_r($pvars, true));
		$app->debug(print_r($cvars, true));
		foreach($vars as $key => $value)
		{
			$app->debug($key.' '.$value);	
		}
		*/

		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
	
		
		
		if($this->id == 0)
		{
			//$app->debug($className." insert");
			
			//$query = sprintf("INSERT INTO ".$className." (username, password, name, email, userLevel, tag, timestamp) VALUES(?, ?, ?, ?, ?, ?, ?)");
			//$st = $db->prepare($query);
			//$st->execute(array($this->username, $this->password, $this->name, $this->email, $this->userLevel, $this->tag, $this->timestamp));
			//this->id = $db->lastInsertId();
			
			
			$vars = get_class_vars($className);
			$keys = array_keys($vars);
			$part1 = $keys[1];
			$part2 = "?";
			$values = array($this->$keys[1]);
			for($i=2;$i<count($keys);$i++)
			{
				$part1 .= ", ".$keys[$i];
				$part2 .= ", ?";
				array_push($values, $this->$keys[$i]);
			}
			$query = sprintf("INSERT INTO %s (%s) VALUES(%s);", $className, $part1, $part2);
			$st = $db->prepare($query);
			$st->execute($values);
			$this->id = $db->lastInsertId();
			
		}
		else
		{
			//$app->debug($className." update");
			
			//$query = sprintf("UPDATE ".$className." SET username=?, password=?, name=?, email=?, userLevel=?, tag=?, timestamp=? WHERE id=?");
			//$st = $db->prepare($query);
			//$st->execute(array($this->username, $this->password, $this->name, $this->email, $this->userLevel, $this->tag, $this->timestamp, $this->id));
			
			
			$vars = get_class_vars($className);
			$keys = array_keys($vars);
			$part1 = $keys[1]."=?";
			$part2 = $keys[0]."=?";
			$values = array($this->$keys[1]);
			for($i=2;$i<count($keys);$i++)
			{
				$part1 .= ", ".$keys[$i]."=?";
				array_push($values, $this->$keys[$i]);
			}
			array_push($values, $this->$keys[0]);
			
			$query = sprintf("UPDATE %s SET %s WHERE %s;", $className, $part1, $part2);
			$st = $db->prepare($query);
			$st->execute($values);
		}
		
		return true;
	}
	
	
	function delete()
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		$app->debug($className." delete");
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
		
		$vars = get_class_vars($className);
		$keys = array_keys($vars);
		$query = sprintf("DELETE FROM %s WHERE %s=%d;", $className, $keys[0], $this->id);
		$st = $db->prepare($query);
		$st->execute();	

		$this->id = 0;
		
		return true;
	}
	
	 
	//!以下是Model共用的static函式
	
	public static function count()
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
		
		$query = sprintf("SELECT COUNT(*) FROM %s;", $className);
		$st = $db->prepare($query);
		$st->execute();
		
		
		$count = $st->fetchColumn();
		return $count;
	}
	
	
	public static function countByConditions($conditions, $values)
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
		
		$query = sprintf("SELECT COUNT(*) FROM %s %s;", $className, $conditions);
		$st = $db->prepare($query);
		$st->execute($values);
		
		
		$count = $st->fetchColumn();
		return $count;
	}

	
	public static function find($id)
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
		
		$vars = get_class_vars($className);
		$keys = array_keys($vars);
		$query = sprintf("SELECT * FROM %s WHERE %s=%d;", $className, $keys[0], $id);
		$st = $db->prepare($query);
		$st->execute();
		
		$row = $st->fetch(PDO::FETCH_ASSOC);
		if($row == false)
		{
			return null;
		}
		
		$object = new $className;		
		foreach($row as $key => $value)
		{
			$object->$key = $value;
		}
		
		return $object;
	}
	
	
	public static function findByConditions($conditions, $values)
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
		
		$query = sprintf("SELECT * FROM %s %s;", $className, $conditions);
		$st = $db->prepare($query);
		$st->execute($values);
		
		
		$objects = array();
		
		while($row = $st->fetch(PDO::FETCH_ASSOC))
		{
			$object = new $className;		
			foreach($row as $key => $value)
			{
				$object->$key = $value;
			}
			array_push($objects, $object);
		}
		
		return $objects;
	}
	
	
	public static function deleteAll()
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
		
		$query = sprintf("DELETE FROM %s;", $className);
		$st = $db->prepare($query);
		$st->execute();
		
		return true;
	}
	
	
	public static function deleteByConditions($conditions, $values)
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
		
		$query = sprintf("DELETE FROM %s %s;", $className, $conditions);
		$st = $db->prepare($query);
		$st->execute($values);
		
		return true;
	}
	

	
	public static function queryBySQL($sql, $values)
	{
		$app = UIApplication::sharedApplication();
		$className = get_called_class();
		
		
		$db = null;
		if($app->dbType == 'mysql')
		{	
			$db = new PDO('mysql:'.$app->dbLocation, $app->dbUsername, $app->dbPassword);
			$db->exec("SET NAMES utf8");
		}
		else
		{
			$db = new PDO('sqlite:'.$app->dbFileName);
		}
		
	
		$st = $db->prepare($sql);
		$st->execute($values);
		
		return $st;
	}
	

}

?>